# Python imports

# Lib imports
import gi
gi.require_version('Gtk', '3.0')
gi.require_version('GtkSource', '4')
from gi.repository import Gtk
from gi.repository import GtkSource

# Application imports
from .dynamic_widget import DynamicWidget



class DragArea(GtkSource.View):
# class DragArea(Gtk.Fixed):
    def __init__(self):
        super(DragArea, self).__init__()

        self.buffer = self.get_buffer()
        self._children_content = []

        self._setup_styling()
        self._setup_signals()
        self._subscribe_to_events()
        self._load_widgets()


    def _setup_styling(self):
        self.set_size_request(1800, 1800)
        self.set_cursor_visible(False)

    def _setup_signals(self):
        ...

    def _subscribe_to_events(self):
        ...

    def _load_widgets(self):
        ...

    def add_fixed_base_widgets(self, name = None, date = None, update_header_callback = None):
        entry      = Gtk.Entry(text  = name)
        date_label = Gtk.Label(label = date)

        ctx = entry.get_style_context()
        ctx.add_class("drag-area-title")

        entry.connect("changed", update_header_callback)
        entry.set_width_chars(25)
        entry.set_max_length(25)

        # self.put(entry, 30, 30)
        # self.put(date_label, 30, 65)
        self.add_child_in_window(entry, Gtk.TextWindowType.WIDGET, 30, 30)
        self.add_child_in_window(date_label, Gtk.TextWindowType.WIDGET, 30, 65)

    def add_or_select_widget(self, widget = None, eve = None):
        dynamic_widget = DynamicWidget(self._move_callback, eve.x, eve.y)

        self._children_content.append(dynamic_widget)
        # self.put(dynamic_widget, eve.x, eve.y)
        self.add_child_in_window(dynamic_widget, Gtk.TextWindowType.WIDGET, eve.x, eve.y)

    def _move_callback(self, widget = None, x = None, y = None):
        # self.move(widget, x, y)
        self.move_child(widget, x, y)
